<template>
  <form
    class="fr-container--fluid"
    @submit.prevent="onUpdateOrganisation"
  >
    <OrganisationFormInformation :organisation="organisation" />

    <OrganisationFormFollowUpTypes
      :follow-up-types="followUpTypes"
      :organisation-follow-up-types="organisation.follow_up_types"
      @follow-up-type-created="createdFollowUpTypes.push($event)"
    />

    <button
      class="fr-btn fr-btn--lg submit-btn"
      type="submit"
      :disabled="isSubmitting"
      :submitting="isSubmitting"
    >
      Modifier ma structure
    </button>
  </form>
</template>

<script setup>
  import { ref, watch } from 'vue'
  import { prepareFollowUpTypes } from '~~/utils/organisationForm'

  const props = defineProps({
    organisation: { type: Object, required: true },
    followUpTypes: { type: Array, required: true },
    isSubmitting: { type: Boolean, required: true }
  })

  const emit = defineEmits(['updateOrganisation'])

  const createdFollowUpTypes = ref([])

  watch(
    () => props.organisation,
    () => {
      createdFollowUpTypes.value = []
    }
  )

  function onUpdateOrganisation({ target }) {
    const organisation = Object.fromEntries(new FormData(target))
    const selectedFollowUpTypeIds = [
      ...(organisation.legalFollowUpTypes || '').split(','),
      ...(organisation.optionalFollowUpTypes || '').split(',')
    ]
    organisation.follow_up_types = prepareFollowUpTypes(
      props.organisation.follow_up_types,
      selectedFollowUpTypeIds,
      createdFollowUpTypes.value
    )
    delete organisation.legalFollowUpTypes
    delete organisation.optionalFollowUpTypes

    emit('updateOrganisation', organisation)
  }
</script>
